"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const cryptography = __importStar(require("@liskhq/lisk-cryptography"));
exports.getAddressAndPublicKeyFromRecipientData = ({ recipientId, recipientPublicKey, }) => {
    if (recipientId && recipientPublicKey) {
        const addressFromPublicKey = cryptography.getAddressFromPublicKey(recipientPublicKey);
        if (recipientId === addressFromPublicKey) {
            return { address: recipientId, publicKey: recipientPublicKey };
        }
        throw new Error('Could not create transaction: recipientId does not match recipientPublicKey.');
    }
    if (!recipientId && recipientPublicKey) {
        const addressFromPublicKey = cryptography.getAddressFromPublicKey(recipientPublicKey);
        return { address: addressFromPublicKey, publicKey: recipientPublicKey };
    }
    return { address: recipientId, publicKey: undefined };
};
//# sourceMappingURL=get_address_and_public_key_from_recipient_data.js.map