/// <reference types="node" />
import { BaseTransaction, DappAsset, DelegateAsset, InTransferAsset, MultiSignatureAsset, OutTransferAsset, SecondSignatureAsset, TransactionAsset, TransferAsset, VoteAsset } from '../transaction_types';
export declare const isValidValue: (value: unknown) => boolean;
export declare const checkRequiredFields: (requiredFields: ReadonlyArray<string>, data: {
    readonly [key: string]: unknown;
}) => boolean;
export declare const getAssetDataForTransferTransaction: (asset: TransactionAsset) => Buffer;
export declare const getAssetDataForRegisterSecondSignatureTransaction: (asset: TransactionAsset) => Buffer;
export declare const getAssetDataForRegisterDelegateTransaction: (asset: TransactionAsset) => Buffer;
export declare const getAssetDataForCastVotesTransaction: (asset: TransactionAsset) => Buffer;
export declare const getAssetDataForRegisterMultisignatureAccountTransaction: (asset: TransactionAsset) => Buffer;
export declare const getAssetDataForCreateDappTransaction: (asset: TransactionAsset) => Buffer;
export declare const getAssetDataForTransferIntoDappTransaction: (asset: TransactionAsset) => Buffer;
export declare const getAssetDataForTransferOutOfDappTransaction: (asset: TransactionAsset) => Buffer;
export declare const getAssetBytes: (transaction: BaseTransaction) => Buffer;
export declare const checkTransaction: (transaction: {
    readonly amount?: string | undefined;
    readonly asset?: TransferAsset | SecondSignatureAsset | DelegateAsset | VoteAsset | MultiSignatureAsset | DappAsset | InTransferAsset | OutTransferAsset | undefined;
    readonly fee?: string | undefined;
    readonly id?: string | undefined;
    readonly recipientId?: string | null | undefined;
    readonly recipientPublicKey?: string | null | undefined;
    readonly requesterPublicKey?: string | undefined;
    readonly senderId?: string | undefined;
    readonly senderPublicKey?: string | undefined;
    readonly signature?: string | undefined;
    readonly signatures?: ReadonlyArray<string> | undefined;
    readonly signSignature?: string | undefined;
    readonly timestamp?: number | undefined;
    readonly type?: number | undefined;
}) => boolean;
export declare const getTransactionBytes: (transaction: BaseTransaction) => Buffer;
